#!/bin/bash
# certificado.sh

case $1 in
	"--help" | "-h" | "")
		echo "Uso: ./certificado [opcoes] lista_de_alunos[.txt] template_latex[.tex]"
		echo "opcoes:"
		echo "  --help,  -h : Imprime esta ajuda"
		echo "  --files, -f : Cria um arquivo em disco (formato ps) para cada aluno na lista"
		echo "                especificada. Se nenhuma opcao for fornecida, esta sera a acao"
		echo "                default"
		echo "  --print, -p : Envia os certificados gerados para a impressora padrao"
		#~ echo "                "
		echo "    "
		echo "  A lista de alunos deve ser um arquivo texto contendo os nomes dos alunos, um"
		echo "um por linha."
		echo "  O template LaTeX deve conter '%NOME_DO_ALUNO' onde o nome do aluno deve"
		echo "aparecer no texto, ou seja, %NOME_DO_ALUNO sera substituido pelo nome do aluno"
		echo "    "
		
		exit 0
	;;
	"--print" | "-p")
	# Se o arquivo existe
	if [ -f "$2" ];
	then
		if [ -f "$3" ];
		then
			TEMPLATE_LATEX=$3
			
			# redireciona a entrada padrao para o arquivo dado
			exec < $2
			
			COMANDO=1
		else
			echo "O arquivo \"$3\" nao existe"
			exit 1
		fi
	else
		echo "O arquivo \"$2\" nao existe"
		exit 1
	fi
	;;
	"--files" | "-f")
	# Se o arquivo existe
	if [ -f "$2" ];
	then
		if [ -f "$3" ];
		then
			TEMPLATE_LATEX=$3
			
			# redireciona a entrada padrao para o arquivo dado
			exec < $2
		else
			echo "O arquivo \"$3\" nao existe"
			exit 1
		fi
	else
		echo "O arquivo \"$2\" nao existe"
		exit 1
	fi
	;;
	*)
	# Se o arquivo existe
	if [ -f "$1" ];
	then
		if [ -f "$2" ];
		then
			TEMPLATE_LATEX=$2
			
			# redireciona a entrada padrao para o arquivo dado
			exec < $1
		else
			echo "O arquivo \"$2\" nao existe"
			exit 1
		fi
	else
		echo "O arquivo \"$1\" nao existe"
		exit 1
	fi
	;;
esac

# criando os certificados e imprimindo/salvando-os

# enquanto houverem linhas a serem lidas no aquivo...
while read LINE
do
	# se a linha nao for vazia
	if [ "$LINE" != "" ];
	then
		cp "$TEMPLATE_LATEX" _temp_.tex
		replace %NOME_DO_ALUNO "$LINE" -- _temp_.tex 1>/dev/null
		latex "_temp_.tex" 1>/dev/null
		dvips -o "$LINE.ps" _temp_ 1>/dev/null 2>/dev/null
		rm "_temp_.aux" "_temp_.log" "_temp_.tex" "_temp_.dvi"
		
		if [[ $COMANDO = 1 ]]
		then
			lp "$LINE.ps"
			rm "$LINE.ps"
		fi
	fi
done

exit 0